#!/bin/sh
#------------------------------------------------------------------------------
# dyndns.cgi - display the answers from the dyndns services
#
# Creation:     2001-08-27  twm
#
#------------------------------------------------------------------------------

myname=`basename $0`

convname ( ) {
  local part
  local nam
  
  nam=""

  for part in `echo $1 | tr "." " "` ; do
    if [ "$part" != "/var/run/answer" ] ; then
      if [ "$nam" != "" ] ; then
        nam="$nam."
      fi
      nam="$nam""$part"
    fi
  done
  echo -n "$nam"

  return 0
}


echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo "<html><head>"
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo "<title>Answers from DynDNS services</title>"
echo "</head><body>"

echo '<table border="0" width="95%" cellspacing="0" cellpadding="0" align="center"><tr>'
echo '<th align="left" bgcolor="#C0C0C0"><b>Answers from DynDNS services</b></th>'
echo '</tr>'

echo '<tr><td>'
echo 'This table shows the answers the router got from'
echo 'the services configured in'
echo '<a href="http://www.s2h.cx" target="_top">OPT_DYNDNS</a>.'
echo '</td></tr>'

echo '<tr><td>'
echo "<table width=\"100%\" border=\"1\" cellpadding=\"5\">"
echo "<tr><th align=\"left\">service</th><th align=\"left\">answer</th></tr>"

# I don't like this, it works but it seems more complicated than it should
# be. Anybody got a better idea how to check whether there are any
# files matching '/var/run/answer.*' ?
ANSWERS=`ls /var/run/answer.* 2>&1 | sed s/ls:.\*//`
if [ -n "$ANSWERS" ] ; then
  for fn in $ANSWERS ; do
    echo "<tr><td valign=\"top\" align=\"left\">"
    convname $fn
    echo '</td><td><pre>'
    cat $fn | \
    # save error codes from ZoneEdit from being removed as html tags
    sed -e 's/<ERROR /ERROR /g' -e 's/<SUCCESS /SUCCESS /g' | \
    # remove html comments
    sed -e '/<!--/!b; :a; /-->/!{; N; ba; }; s/<!--.*-->//' | \
    # remove most html tags
    sed -e ':a' -e 's/<[^<]*>/ /g; /</{N; s/\n/ /; ba;}'
    echo '</pre></td></tr>'
  done
fi

echo "</table></td></tr></table></body></html>"
